diff --git a/krita/ui/canvas/kis_image_pyramid.h b/krita/ui/canvas/kis_image_pyramid.h
index c863e95..a197850 100644
--- a/krita/ui/canvas/kis_image_pyramid.h
+++ b/krita/ui/canvas/kis_image_pyramid.h
@@ -28,7 +28,6 @@
 #include <kis_paint_device.h>
 #include "kis_projection_backend.h"
 
-
 class KisImagePyramid : QObject, public KisProjectionBackend
 {
     Q_OBJECT
@@ -40,17 +39,11 @@ public:
     void setImage(KisImageWSP newImage);
     void setImageSize(qint32 w, qint32 h);
     void setMonitorProfile(const KoColorProfile* monitorProfile);
-    void setDirty(const QRect& rc);
-
-    KisImagePatch getNearestPatch(qreal scaleX, qreal scaleY,
-                                  const QRect& requestedRect,
-                                  qint32 borderWidth);
+    void updateCache(KisPPUpdateInfoSP info);
+    void recalculateCache(KisPPUpdateInfoSP info);
 
-    void drawFromOriginalImage(QPainter& gc,
-                               const QRect& imageRect,
-                               const QRectF& viewportRect,
-                               qint32 borderWidth,
-                               QPainter::RenderHints renderHints);
+    KisImagePatch getNearestPatch(KisPPUpdateInfoSP info);
+    void drawFromOriginalImage(QPainter& gc, KisPPUpdateInfoSP info);
 
     /**
      * Render the projection onto a QImage.
@@ -91,6 +84,7 @@ private:
     qint32 m_pyramidHeight;
 
 private:
+    void retrieveImageData(const QRect &rect);
     void rebuildPyramid();
     void clearPyramid();
 
diff --git a/krita/ui/canvas/kis_prescaled_projection.cpp b/krita/ui/canvas/kis_prescaled_projection.cpp
index 2ed08df..10d3605 100644
--- a/krita/ui/canvas/kis_prescaled_projection.cpp
+++ b/krita/ui/canvas/kis_prescaled_projection.cpp
@@ -22,13 +22,11 @@
 #include <math.h>
 
 #include <QImage>
-#include <QPixmap>
 #include <QColor>
 #include <QRect>
 #include <QPoint>
 #include <QSize>
 #include <QPainter>
-#include <QTimer>
 
 #include <KoColorProfile.h>
 #include <KoColorSpaceRegistry.h>
@@ -37,21 +35,21 @@
 #include "kis_config.h"
 #include "kis_config_notifier.h"
 #include "kis_image.h"
-#include "kis_layer.h"
-#include "kis_mask.h"
-#include "kis_node.h"
-#include "kis_paint_device.h"
-#include "kis_paint_layer.h"
-#include "kis_selection.h"
-#include "kis_selection_mask.h"
-#include "kis_types.h"
 
+#include "kis_projection_backend.h"
 #include "kis_projection_cache.h"
 #include "kis_image_pyramid.h"
 
 
 #define EPSILON 1e-10
 
+#define ceiledSize(sz) QSize(ceil((sz).width()), ceil((sz).height()))
+#define SCALE_LESS_THAN(scX, scY, value) \
+    (scX < (value) - EPSILON && scY < (value) - EPSILON)
+#define SCALE_MORE_OR_EQUAL_TO(scX, scY, value) \
+    (scX > (value) - EPSILON && scY > (value) - EPSILON)
+#define BORDER_SIZE(scale) (ceil(scale * 2))
+
 inline void copyQImageBuffer(uchar* dst, const uchar* src , qint32 deltaX, qint32 width)
 {
     if (deltaX >= 0) {
@@ -84,37 +82,25 @@ void copyQImage(qint32 deltaX, qint32 deltaY, QImage* dstImage, const QImage& sr
 struct KisPrescaledProjection::Private {
     Private()
             : useNearestNeighbour(false)
-            , usePixmapNotQImage(false)
-            , drawCheckers(false)
-            , scrollCheckers(false)
-            , drawMaskVisualisationOnUnscaledCanvasCache(false)
-            , showMask(true)
             , cacheKisImageAsQImage(true)
-            , checkSize(32)
             , documentOffset(0, 0)
             , documentOrigin(0, 0)
             , canvasSize(0, 0)
             , imageSize(0, 0)
             , viewConverter(0)
             , monitorProfile(0)
-            , counter(0)
             , projectionBackend(0) {
     }
 
+    /**
+     * TODO: useNearestNeighbour is not used at the moment
+     * thought this option worth implementing (ok, yeah.. reimplementing)
+     */
     bool useNearestNeighbour;
-    bool usePixmapNotQImage;
     bool useMipmapping;
-    bool drawCheckers;
-    bool scrollCheckers;
-    bool drawMaskVisualisationOnUnscaledCanvasCache;
-    bool showMask;
     bool cacheKisImageAsQImage;
 
-    QColor checkersColor;
-    qint32 checkSize;
     QImage prescaledQImage;
-    QPixmap prescaledPixmap;
-
 
     QPoint documentOffset; // in view pixels
     QPoint documentOrigin; // in view pixels too
@@ -123,10 +109,7 @@ struct KisPrescaledProjection::Private {
     QSize imageSize; // in kisimage pixels
     KisImageWSP image;
     KoViewConverter * viewConverter;
-    KisNodeSP currentNode;
-    QRegion rectsToSmooth;
     const KoColorProfile* monitorProfile;
-    int counter;
     KisProjectionBackend* projectionBackend;
 };
 
@@ -156,23 +139,6 @@ void KisPrescaledProjection::setImage(KisImageWSP image)
     setImageSize(image->width(), image->height());
 }
 
-
-bool KisPrescaledProjection::drawCheckers() const
-{
-    return m_d->drawCheckers;
-}
-
-
-void KisPrescaledProjection::setDrawCheckers(bool drawCheckers)
-{
-    m_d->drawCheckers = drawCheckers;
-}
-
-QPixmap KisPrescaledProjection::prescaledPixmap() const
-{
-    return m_d->prescaledPixmap;
-}
-
 QImage KisPrescaledProjection::prescaledQImage() const
 {
     return m_d->prescaledQImage;
@@ -204,7 +170,6 @@ void KisPrescaledProjection::updateSettings()
 {
     KisConfig cfg;
 
-
     if (m_d->useNearestNeighbour != cfg.useNearestNeighbour() ||
         m_d->useMipmapping != cfg.useMipmapping() ||
         m_d->cacheKisImageAsQImage != cfg.cacheKisImageAsQImage() ||
@@ -217,15 +182,6 @@ void KisPrescaledProjection::updateSettings()
         initBackend(m_d->useMipmapping, m_d->cacheKisImageAsQImage);
     }
 
-    m_d->usePixmapNotQImage = cfg.noXRender();
-
-    // If any of the above are true, we don't use our own smooth scaling
-    m_d->scrollCheckers = cfg.scrollCheckers();
-    m_d->checkSize = cfg.checkSize();
-    m_d->checkersColor = cfg.checkersColor();
-
-    m_d->drawMaskVisualisationOnUnscaledCanvasCache = cfg.drawMaskVisualisationOnUnscaledCanvasCache();
-
     setMonitorProfile(KoColorSpaceRegistry::instance()->profileByName(cfg.monitorProfile()));
 }
 
@@ -282,7 +238,11 @@ void KisPrescaledProjection::documentOffsetMoved(const QPoint &documentOffset)
                 // enough image to draw in them.
                 gc.fillRect(r, QColor(0, 0, 0, 0));
                 dbgRender << "render on rect" << r;
-                drawScaledImage(r , gc);
+                /**
+                 * FIXME: It can happen that we will need access to KisImage here
+                 */
+                KisPPUpdateInfoSP info = getUpdateInformation(r, QRect());
+                drawUsingBackend(gc, info);
             }
         }
         m_d->prescaledQImage = image;
@@ -295,73 +255,52 @@ void KisPrescaledProjection::documentOffsetMoved(const QPoint &documentOffset)
 
 void KisPrescaledProjection::setImageSize(qint32 w, qint32 h)
 {
-
     m_d->projectionBackend->setImageSize(w, h);
 
     m_d->imageSize = QSize(w, h);
 
-    QRect vRect = toAlignedRectWorkaround(viewRectFromImagePixels(QRect(0, 0, w, h)));
+    QRect vRect = viewRectFromImagePixels(QRect(0, 0, w, h)).toAlignedRect();
     vRect = vRect.intersected(QRect(QPoint(0, 0), m_d->canvasSize));
     if (!vRect.isEmpty()) {
         preScale(vRect);
     }
 }
 
-QRect KisPrescaledProjection::updateCanvasProjection(const QRect & rc)
+KisUpdateInfoSP
+KisPrescaledProjection::updateCache(const QRect &dirtyImageRect)
 {
     if (!m_d->image) {
-        dbgRender << "Calling updateCanvasProjection without an image: " << kBacktrace() << endl;
-        return QRect();
+        dbgRender << "Calling updateCache without an image: " << kBacktrace() << endl;
+        // return invalid info
+        return new KisPPUpdateInfo();
     }
 
     /**
-     * FIXME: leave only one of these intersections: canvas or image
-     */
-
-    /**
      * We needn't this stuff ouside KisImage's area. Lets user
      * paint there, anyway we won't show him anything =)
      */
-    if (!rc.intersects(m_d->image->bounds()))
-        return QRect();
-
-    m_d->projectionBackend->setDirty(rc);
-
-    QRect viewRect = toAlignedRectWorkaround(viewRectFromImagePixels(rc));
-    viewRect = viewRect.intersected(QRect(QPoint(0, 0), m_d->canvasSize));
-    QRect newViewRect;
+    if (!dirtyImageRect.intersects(m_d->image->bounds()))
+        return new KisPPUpdateInfo();
 
-    if (!viewRect.isEmpty()) {
-        newViewRect = preScale(viewRect);
+    QRect rawViewRect = viewRectFromImagePixels(dirtyImageRect).toAlignedRect();
+    KisPPUpdateInfoSP info = getUpdateInformation(rawViewRect, dirtyImageRect);
 
-        if (newViewRect != viewRect) {
-            dbgRender << "canvas size:" << m_d->canvasSize;
-            dbgRender << "viewRect before alignment:" << viewRect;
-            dbgRender << "viewRect after alignment: " << newViewRect;
-        }
-    }
+    m_d->projectionBackend->updateCache(info);
 
-    return newViewRect;
+    return info;
 }
 
-
-void KisPrescaledProjection::setMonitorProfile(const KoColorProfile * profile)
+void KisPrescaledProjection::recalculateCache(KisUpdateInfoSP info)
 {
-    m_d->monitorProfile = profile;
-    m_d->projectionBackend->setMonitorProfile(profile);
-}
+    KisPPUpdateInfoSP ppInfo = dynamic_cast<KisPPUpdateInfo*>(info.data());
+    if(!ppInfo) return;
 
-void KisPrescaledProjection::setCurrentNode(const KisNodeSP node)
-{
-    m_d->currentNode = node;
-}
+    m_d->projectionBackend->recalculateCache(ppInfo);
 
-void KisPrescaledProjection::showCurrentMask(bool showMask)
-{
-    m_d->showMask = showMask;
+    if(!info->dirtyViewportRect().isEmpty())
+        updateScaledImage(ppInfo);
 }
 
-
 void KisPrescaledProjection::preScale()
 {
     Q_ASSERT(m_d->canvasSize.isValid());
@@ -370,14 +309,26 @@ void KisPrescaledProjection::preScale()
 
 QRect KisPrescaledProjection::preScale(const QRect & rc)
 {
-    QRect retval;
-    if (!rc.isEmpty()) {
+    if (!rc.isEmpty() && m_d->image) {
+        /**
+         * FIXME: It can happen that we will need access to KisImage here
+         */
+        KisPPUpdateInfoSP info = getUpdateInformation(rc, QRect());
+
         QPainter gc(&m_d->prescaledQImage);
         gc.setCompositionMode(QPainter::CompositionMode_Source);
         gc.fillRect(rc, QColor(0, 0, 0, 0));
-        retval = drawScaledImage(rc, gc);
+        drawUsingBackend(gc, info);
+        //FIXME: leave one of those rects, probably, first.
+        return rc | info->viewportRect.toAlignedRect();
     }
-    return retval;
+    return QRect();
+}
+
+void KisPrescaledProjection::setMonitorProfile(const KoColorProfile * profile)
+{
+    m_d->monitorProfile = profile;
+    m_d->projectionBackend->setMonitorProfile(profile);
 }
 
 void KisPrescaledProjection::resizePrescaledImage(const QSize & newSize)
@@ -396,45 +347,23 @@ void KisPrescaledProjection::resizePrescaledImage(const QSize & newSize)
     QImage image = QImage(newSize, QImage::Format_ARGB32);
 //     m_d->prescaledQImage.fill( QColor( 255, 0, 0, 128 ).rgba() );
 
-// Let someone else figure out the optimization where we copy the
+// FIXME: Let someone else figure out the optimization where we copy the
 // still visible part of the image after moving the offset and then
 // only draw the newly visible parts
-#if 0
-    QPainter gc(&image);
-    gc.setCompositionMode(QPainter::CompositionMode_Source);
-
-    if (newSize.width() > oldSize.width() || newSize.height() > oldSize.height()) {
-
-        gc.drawImage(0, 0,
-                     m_d->prescaledQImage,
-                     0, 0, m_d->prescaledQImage.width(), m_d->prescaledQImage.height());
-
-        QRegion r(QRect(0, 0, newSize.width(), newSize.height()));
-        r -= QRegion(QRect(0, 0, m_d->prescaledQImage.width(), m_d->prescaledQImage.height()));
-        foreach(QRect rc, r.rects()) {
-            drawScaledImage(rc, gc);
-        }
-    } else {
-        gc.drawImage(0, 0, m_d->prescaledQImage,
-                     0, 0, m_d->prescaledQImage.width(), m_d->prescaledQImage.height());
-    }
-#endif
 
-#if 1
     m_d->prescaledQImage = image;
     m_d->canvasSize = newSize;
     preScale();
-#endif
-
 }
 
-QRect KisPrescaledProjection::drawScaledImage(const QRect & rc,  QPainter & gc)
+KisPPUpdateInfoSP
+KisPrescaledProjection::getUpdateInformation(const QRect &viewportRect,
+                                             const QRect &dirtyImageRect)
 {
-    if (!m_d->image)
-        return QRect();
-
     Q_ASSERT(m_d->viewConverter);
 
+    KisPPUpdateInfoSP info = new KisPPUpdateInfo();
+
     // get the x and y zoom level of the canvas
     qreal zoomX, zoomY;
     m_d->viewConverter->zoom(&zoomX, &zoomY);
@@ -444,67 +373,71 @@ QRect KisPrescaledProjection::drawScaledImage(const QRect & rc,  QPainter & gc)
     qreal resY = m_d->image->yRes();
 
     // Compute the scale factors
-    qreal scaleX = zoomX / resX;
-    qreal scaleY = zoomY / resY;
+    info->scaleX = zoomX / resX;
+    info->scaleY = zoomY / resY;
 
-    QRect updateRectInImagePixels = imageRectFromViewPortPixels(toFloatRectWorkaround(rc));
+    // save it for future
+    info->dirtyImageRect = dirtyImageRect;
 
-    m_d->projectionBackend->alignSourceRect(updateRectInImagePixels, scaleX);
+    // first, crop the part of the view rect that is outside of the canvas
+    QRect croppedViewRect = viewportRect.intersected(QRect(QPoint(0, 0), m_d->canvasSize));
 
-    QRectF updateRect = viewRectFromImagePixels(updateRectInImagePixels);
+    // second, align this rect to the KisImage's pixels and pixels
+    // of projection backend
+    info->imageRect = imageRectFromViewPortPixels(QRectF(croppedViewRect));
+    m_d->projectionBackend->alignSourceRect(info->imageRect, info->scaleX);
 
+    // finally, compute the dirty rect of the canvas
+    info->viewportRect = viewRectFromImagePixels(info->imageRect);
 
-    drawUsingBackend(m_d->projectionBackend, gc, scaleX, scaleY,
-                     updateRectInImagePixels, updateRect);
+    info->borderWidth = 0;
+    if (SCALE_MORE_OR_EQUAL_TO(info->scaleX, info->scaleY, 1.0)) {
+        if (SCALE_LESS_THAN(info->scaleX, info->scaleY, 2.0)) {
+            dbgRender << "smoothBetween100And200Percent" << endl;
+            info->renderHints = QPainter::SmoothPixmapTransform;
+            info->borderWidth = BORDER_SIZE(qMax(info->scaleX, info->scaleY));
+        }
+        info->transfer = KisPPUpdateInfo::DIRECT;
+    } else { // <100%
+        info->renderHints = QPainter::SmoothPixmapTransform;
+        info->borderWidth = BORDER_SIZE(qMax(info->scaleX, info->scaleY));
+        info->transfer = KisPPUpdateInfo::PATCH;
+    }
 
     dbgRender << "#####################################";
     dbgRender << ppVar(resX) << ppVar(resY);
     dbgRender << ppVar(zoomX) << ppVar(zoomY);
-    dbgRender << ppVar(scaleX) << ppVar(scaleY);
-    dbgRender << ppVar(rc);
-    dbgRender << "Update rect in KisImage's pixels:\t" << updateRectInImagePixels;
-    dbgRender << "Update rect in canvas' pixels:\t" << updateRect;
+    dbgRender << ppVar(info->scaleX) << ppVar(info->scaleY);
+    dbgRender << ppVar(info->borderWidth) << ppVar(info->renderHints);
+    dbgRender << ppVar(info->transfer);
+    dbgRender << ppVar(dirtyImageRect);
+    dbgRender << "Not aligned rect of the canvas (raw):\t" << croppedViewRect;
+    dbgRender << "Update rect in KisImage's pixels:\t" << info->imageRect;
+    dbgRender << "Update rect in canvas' pixels:\t" << info->viewportRect;
     dbgRender << "#####################################";
 
-    return toAlignedRectWorkaround(updateRect);
+    return info;
 }
 
-
-#define ceiledSize(sz) QSize(ceil((sz).width()), ceil((sz).height()))
-#define SCALE_LESS_THAN(scX, scY, value) \
-    (scX < (value) - EPSILON && scY < (value) - EPSILON)
-#define SCALE_MORE_OR_EQUAL_TO(scX, scY, value) \
-    (scX > (value) - EPSILON && scY > (value) - EPSILON)
-#define BORDER_SIZE(scale) (ceil(scale * 2))
-
-void KisPrescaledProjection::drawUsingBackend(KisProjectionBackend *backend,
-        QPainter &gc,
-        qreal &scaleX, qreal &scaleY,
-        const QRect   &imageRect,
-        const QRectF  &viewportRect)
+void KisPrescaledProjection::updateScaledImage(KisPPUpdateInfoSP info)
 {
-    if (imageRect.isEmpty()) return;
+    QPainter gc(&m_d->prescaledQImage);
+    gc.setCompositionMode(QPainter::CompositionMode_Source);
+//    gc.fillRect(viewRectFromImagePixels(info->dirtyImageRect).toAlignedRect(), QColor(255, 0, 0, 255));
+    drawUsingBackend(gc, info);
+}
 
-    if (SCALE_MORE_OR_EQUAL_TO(scaleX, scaleY, 1.0)) {
-        QPainter::RenderHints renderHints;
-        qint32 borderWidth = 0;
+void KisPrescaledProjection::drawUsingBackend(QPainter &gc, KisPPUpdateInfoSP info)
+{
+    if (info->imageRect.isEmpty()) return;
 
-        if (SCALE_LESS_THAN(scaleX, scaleY, 2.0)) {
-            dbgRender << "smoothBetween100And200Percent" << endl;
-            renderHints = QPainter::SmoothPixmapTransform;
-            borderWidth = BORDER_SIZE(qMax(scaleX, scaleY));
-        }
-        backend->drawFromOriginalImage(gc, imageRect, viewportRect,
-                                       borderWidth,
-                                       renderHints);
-    } else { // <100%
-        KisImagePatch patch =
-            backend->getNearestPatch(scaleX, scaleY,
-                                     imageRect,
-                                     BORDER_SIZE(qMax(scaleX, scaleY)));
+    if (info->transfer == KisPPUpdateInfo::DIRECT) {
+        m_d->projectionBackend->drawFromOriginalImage(gc, info);
+    } else /* if info->transfer == KisPPUpdateInformation::PATCH */ {
+        KisImagePatch patch = m_d->projectionBackend->getNearestPatch(info);
 
         //patch.prescaleWithBlitz(viewportRect);
-        patch.drawMe(gc, viewportRect, QPainter::SmoothPixmapTransform);
+        patch.drawMe(gc, info->viewportRect, info->renderHints);
     }
 }
 
@@ -515,7 +448,7 @@ QRectF KisPrescaledProjection::viewRectFromImagePixels(const QRect& rc)
     qreal xRes = m_d->image->xRes();
     qreal yRes = m_d->image->yRes();
 
-    QRectF imageRect = toFloatRectWorkaround(rc);
+    QRectF imageRect(rc);
 
     QRectF docRect;
     docRect.setCoords(imageRect.left() / xRes, imageRect.top() / yRes,
@@ -542,7 +475,7 @@ QRect KisPrescaledProjection::imageRectFromViewPortPixels(const QRectF& viewport
     QRectF translatedRect = intersectedRect.translated(m_d->documentOffset);
     QRectF docRect = m_d->viewConverter->viewToDocument(translatedRect);
 
-    return toAlignedRectWorkaround(m_d->image->documentToPixel(docRect)).intersected(m_d->image->bounds());
+    return m_d->image->documentToPixel(docRect).toAlignedRect().intersected(m_d->image->bounds());
 }
 
 
@@ -551,44 +484,4 @@ void KisPrescaledProjection::updateDocumentOrigin(const QPoint& documentOrigin)
     m_d->documentOrigin = documentOrigin;
 }
 
-
-QRectF toFloatRectWorkaround(const QRect& rc)
-{
-    QRectF temp;
-
-    /**
-     * We can't use setCoords here due to "history reasons",
-     * mentioned in Qt documentation.
-     * More than that we make rounding process more stable
-     * with cropping the rect by EPSILON
-     */
-    temp.setRect(rc.left() + EPSILON, rc.top() + EPSILON,
-                 rc.width() - 2 * EPSILON, rc.height() - 2 * EPSILON);
-
-    return temp;
-}
-
-QRect toAlignedRectWorkaround(const QRectF& rc)
-{
-    qreal x1, y1, x2, y2;
-    rc.getCoords(&x1, &y1, &x2, &y2);
-
-    x1 = floor(x1);
-    y1 = floor(y1);
-    x2 = ceil(x2);
-    y2 = ceil(y2);
-
-    QRect ret;
-
-    /**
-     * We can't use setCoords here due to "history reasons",
-     * mentioned in Qt documentation
-     */
-    ret.setRect(x1, y1, x2 - x1, y2 - y1);
-
-    return ret;
-}
-
-
-
 #include "kis_prescaled_projection.moc"
diff --git a/krita/ui/canvas/kis_prescaled_projection.h b/krita/ui/canvas/kis_prescaled_projection.h
index 302e601..26e3753 100644
--- a/krita/ui/canvas/kis_prescaled_projection.h
+++ b/krita/ui/canvas/kis_prescaled_projection.h
@@ -23,7 +23,8 @@
 #include <krita_export.h>
 #include <kis_shared.h>
 
-class QPixmap;
+#include "kis_update_info.h"
+
 class QImage;
 class QPoint;
 class QRect;
@@ -34,8 +35,6 @@ class QPainter;
 class KoViewConverter;
 class KoColorProfile;
 
-class KisProjectionBackend;
-
 #include <kis_types.h>
 
 class KisPrescaledProjection;
@@ -46,11 +45,13 @@ typedef KisSharedPtr<KisPrescaledProjection> KisPrescaledProjectionSP;
  * prescaled QImage representation that is always suitable for
  * painting onto the canvas.
  *
+ * [deprecated]
  * Optionally, the KisPrescaledProjection can also provide a QPixmap
  * with the checkered background blended in.
  *
  * Optionally, the projection can also draw the mask and selection
  * masks and the selection outline.
+ * [/deprecated]
  *
  * The following scaling methods are supported:
  *
@@ -72,7 +73,6 @@ typedef KisSharedPtr<KisPrescaledProjection> KisPrescaledProjectionSP;
 class KRITAUI_EXPORT KisPrescaledProjection : public QObject, public KisShared
 {
     Q_OBJECT
-
 public:
 
     KisPrescaledProjection();
@@ -81,29 +81,6 @@ public:
     void setImage(KisImageWSP image);
 
     /**
-     * @return true if the prescaled projection is set to draw the
-     * checkers, too. In that case, prescaledPixmap returns a complete
-     * pixmap (which doesn't have transparency) and prescaledQImage
-     * returns an empty QImage. This setting is <i>false</i>
-     * initially.
-     */
-    bool drawCheckers() const;
-
-    /**
-     * Set the drawCheckers variable to @param drawCheckers. @see
-     * drawCheckers.
-     */
-    void setDrawCheckers(bool drawCheckers);
-
-    /**
-     * The pre-scaled pixmap includes the underlying checker
-     * represenation. It is only generated when the drawCheckers() is
-     * true, otherwise it is empty. The prescaled pixmal is exactly as
-     * big as the canvas widget in pixels.
-     */
-    QPixmap prescaledPixmap() const;
-
-    /**
      * Return the prescaled QImage. This image has a transparency
      * channel and is therefore suitable for generated a prescaled
      * representation of an image for the KritaShape. The prescaled
@@ -127,6 +104,23 @@ public:
 public slots:
 
     /**
+     * Retrieves image's data from KisImage object and updates
+     * internal cache
+     * @param dirtyImageRect the rect changed on the image
+     * @return prefilled info object that should be used in
+     * the second stage of the update
+     * @see recalculateCache
+     */
+    KisUpdateInfoSP updateCache(const QRect &dirtyImageRect);
+
+    /**
+     * Updates the prescaled cache at current zoom level
+     * @param prefilled update structure returned by updateCache
+     * @see updateCache
+     */
+    void recalculateCache(KisUpdateInfoSP info);
+
+    /**
      * Called whenever the configuration settings change.
      */
     void updateSettings();
@@ -146,15 +140,6 @@ public slots:
     void documentOffsetMoved(const QPoint &documentOffset);
 
     /**
-     * The image projection has changed, now update the canvas
-     * representation of it.
-     *
-     * @param rc the are to be updated in image pixels
-     * @return a rect to be updated in widget pixels
-     */
-    QRect updateCanvasProjection(const QRect & rc);
-
-    /**
      * Called whenever the size of the KisImage changes
      */
     void setImageSize(qint32 w, qint32 h);
@@ -171,76 +156,46 @@ public slots:
     void setMonitorProfile(const KoColorProfile * profile);
 
     /**
-     * Set the current node
-     */
-    void setCurrentNode(const KisNodeSP node);
-
-    /**
-     * Toggle whether the selection should be displayed as a mask.
-     * (The display as ants should be a toggle, too, but is done
-     * elsewhere.)
-     */
-    void showCurrentMask(bool showMask);
-
-
-    /**
      * Called whenever the zoom level changes or another chunk of the
      * image becomes visible. The currently visible area of the image
      * is complete scaled again.
      */
     void preScale();
 
+private:
+    friend class KisPrescaledProjectionTest;
+
+    KisPrescaledProjection(const KisPrescaledProjection &);
+    KisPrescaledProjection operator=(const KisPrescaledProjection &);
+
     /**
      * preScale and draw onto the scaled projection the specified rect,
      * in canvas view pixels.
      */
     QRect preScale(const QRect & rc);
 
-
-signals:
-
     /**
-     * emitted whenever the prescaled image is ready for painting.
-     * This can happen in two stages: a coarse first stage and a
-     * smooth second stage.
+     * Prepare all the information about rects needed during
+     * projection updating
      *
-     * @param rc the updated area in image pixels
+     * @param dirtyImageRect the part of the KisImage that is dirty
      */
-    // FIXME: seems to be not used
-    //void sigPrescaledProjectionUpdated(const QRect & rc);
-
-private:
-    friend class KisPrescaledProjectionTest;
-
-    KisPrescaledProjection(const KisPrescaledProjection &);
-    KisPrescaledProjection operator=(const KisPrescaledProjection &);
+    KisPPUpdateInfoSP getUpdateInformation(const QRect &viewportRect,
+                                           const QRect &dirtyImageRect);
 
     /**
-     * Draw the prescaled image onto the painter.
+     * Initiates the process of prescaled image update
      *
-     * @param rc The desired rect (NOT in KisImage pixels)
-     * It's in viewport pixels
-     * @param gc The painter we draw on
-     * directly to the blitz code
-     * @return a rect actually updated during drawing
-     * it can be greater that @rc do to KisImage alignment
+     * @param info prepared information
      */
-    QRect drawScaledImage(const QRect & rc,  QPainter & gc);
-
+    void updateScaledImage(KisPPUpdateInfoSP info);
 
     /**
-     * Actual drawing is done here
-     * @param imageRect - region of the KisImage to read from
-     * (in KisImage pixels)
-     * @param viewportRect - region of @gc to draw to. Of course
-     * it is in @gc's pixels. Actual image will be scaled down to
-     * fit viewportRect
+     * Atual drawing is done here
+     * @param info prepared information
+     * @param gc The painter we draw on
      */
-    void drawUsingBackend(KisProjectionBackend *backend,
-                          QPainter &gc,
-                          qreal &scaleX, qreal &scaleY,
-                          const QRect   &imageRect,
-                          const QRectF  &viewportRect);
+    void drawUsingBackend(QPainter &gc, KisPPUpdateInfoSP info);
 
     /**
      * Converts image pixels into widget pixels
@@ -264,24 +219,4 @@ private:
     Private * const m_d;
 };
 
-/**
- * A workaroung for Qt's strange behavior of QRect::toAlignedRect()
- */
-KRITAUI_EXPORT QRect toAlignedRectWorkaround(const QRectF& rc);
-
-/**
- * Heh.. "Due to hitory reasons" [1] Qt's QRect::right() doesn't return
- * the coordinate of rightmost side of the rect, it returns
- * the position of the last (rightmost) pixel owned by the rect.
- * However QRectF implements the former case.
- * We workaround it here AND help rounding process a bit.
- * Returned QRectF is ~2e-10 pixels smaller, than original @rc.
- * It doesn't play any role in drawing, but it helps to round up
- * back to @rc afterwards.
- *
- * [1] - see Qt documentation for more
- */
-KRITAUI_EXPORT QRectF toFloatRectWorkaround(const QRect& rc);
-
-
 #endif
diff --git a/krita/ui/canvas/kis_projection_backend.cpp b/krita/ui/canvas/kis_projection_backend.cpp
index 0622bb6..48e073e 100644
--- a/krita/ui/canvas/kis_projection_backend.cpp
+++ b/krita/ui/canvas/kis_projection_backend.cpp
@@ -18,14 +18,6 @@
 
 #include "kis_projection_backend.h"
 
-#include <QRect>
-#include <QRectF>
-#include <QPainter>
-#include "kis_debug.h"
-
-#include <math.h>
-#include <qimageblitz.h>
-
 KisProjectionBackend::~KisProjectionBackend()
 {
 }
@@ -35,54 +27,3 @@ void KisProjectionBackend::alignSourceRect(QRect& rect, qreal scale)
     Q_UNUSED(rect);
     Q_UNUSED(scale);
 }
-
-void KisImagePatch::drawMe(QPainter &gc,
-                           const QRectF &dstRect,
-                           QPainter::RenderHints renderHints)
-{
-    gc.save();
-    gc.setCompositionMode(QPainter::CompositionMode_Source);
-    gc.setRenderHints(renderHints, true);
-    gc.drawImage(dstRect, m_image, m_interestRect);
-    gc.restore();
-
-    /**
-     * Just for debugging purposes
-     */
-    qreal scaleX = dstRect.width() / m_interestRect.width();
-    qreal scaleY = dstRect.height() / m_interestRect.height();
-    dbgRender << "## PATCH.DRAWME #####################";
-    dbgRender << ppVar(scaleX) << ppVar(scaleY);
-    dbgRender << ppVar(m_patchRect);
-    dbgRender << ppVar(m_interestRect);
-    dbgRender << ppVar(dstRect);
-    dbgRender << "## EODM #############################";
-}
-
-#define ceiledSize(sz) QSize(ceil((sz).width()), ceil((sz).height()))
-
-void KisImagePatch::prescaleWithBlitz(QRectF dstRect)
-{
-    qreal scaleX = dstRect.width() / m_interestRect.width();
-    qreal scaleY = dstRect.height() / m_interestRect.height();
-
-    QSize newImageSize = QSize(ceil(m_image.width() * scaleX),
-                               ceil(m_image.height() * scaleY));
-
-    // Calculating new _aligned_ scale
-    scaleX = qreal(newImageSize.width()) / m_image.width();
-    scaleY = qreal(newImageSize.height()) / m_image.height();
-
-    m_scaleX *= scaleX;
-    m_scaleY *= scaleY;
-    scaleRect(m_interestRect, scaleX, scaleY);
-
-    m_image = Blitz::smoothScale(m_image,
-                                 newImageSize,
-                                 Qt::IgnoreAspectRatio);
-
-    dbgRender << "## PATCH.PRESCALEBLITZ ############";
-    dbgRender << ppVar(scaleX) << ppVar(scaleY);
-    dbgRender << ppVar(newImageSize);
-    dbgRender << "## EOB ############################";
-}
